Imports System.Data.Entity.Migrations
Imports Dapper.Domain

Namespace DapperDesigners.Data.EF6.Migrations
    Friend NotInheritable Class Configuration
        Inherits DbMigrationsConfiguration(Of DapperDesigners.Data.EF6.DapperDesignerContext)

        Public Sub New()
            AutomaticMigrationsEnabled = True

        End Sub

        Protected Overrides Sub Seed(ByVal context As DapperDesigners.Data.EF6.DapperDesignerContext)
            '  This method will be called after migrating to the latest version.

            '  You can use the DbSet(Of T).AddOrUpdate() helper extension method 
            '  to avoid creating duplicate seed data. E.g.
            '
            '    context.People.AddOrUpdate(
            '       Function(c) c.FullName,
            '       New Customer() With {.FullName = "Andrew Peters"},
            '       New Customer() With {.FullName = "Brice Lambson"},
            '       New Customer() With {.FullName = "Rowan Miller"})

            Dim julie = New Client With {.Name = "Julie"}
            Dim topfunky = New Client With {.Name = "Geoffrey"}
            Dim magnus = New Client With {.Name = "Magnus"}
            context.Designers.AddOrUpdate(Function(d) New With {Key d.LabelName, Key d.Founder, Key d.Dapperness},
                New DapperDesigner() With {.LabelName = "Top Funky Creations", .Founder = "Guy Vanchey", .Dapperness = Dapperness.PrettyDapper,
                .ContactInfo = New ContactInfo With {.Twitter = "@threadbare"},
                .Clients = New List(Of Client) From {topfunky, magnus},
                .Products = New List(Of Product) From {New Product With {.Description = "Super Skinny Jeans"}, New Product With {.Description = "Shiny Shirt"}}},
               New DapperDesigner With {.LabelName = "Emperor's Clothes", .Founder = "Hans C. Anderson", .Dapperness = Dapperness.SuperDapper,
                .ContactInfo = New ContactInfo With {.Twitter = "@theemperor"},
                .Clients = New List(Of Client) From {magnus},
                .Products = New List(Of Product) From {New Product With {.Description = "Really Really Sheer Shirt"}, New Product With {.Description = "Barely There Pants"}}},
                New DapperDesigner With {.LabelName = "Casa Casual", .Founder = "Julie Lerman", .Dapperness = Dapperness.Dapperless,
                 .ContactInfo = New ContactInfo With {.Twitter = "@casacasual"},
                 .Clients = New List(Of Client) From {julie},
                 .Products = New List(Of Product) From {New Product With {.Description = "Yoga Pants"}, New Product With {.Description = "More Yoga Pants"}}})

            If context.Designers.SingleOrDefault(Function(d) d.LabelName = "Label0") Is Nothing Then
                context.Configuration.AutoDetectChangesEnabled = False
                For i = 0 To 29999
                    context.Designers.Add(New DapperDesigner With {.LabelName = $"Label{i}", .Founder = $"Founder{i}", .Dapperness = Dapperness.KindaDapper, .ContactInfo = New ContactInfo With {.Twitter = "@Label{i}"}})
                Next i
            End If
        End Sub
    End Class
End Namespace
